/*
 File: o2_sdcsym.cpp
 Date and Time: Fri Jan 30 18:55:17 2015 
*/
#include "o2_sdc.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_o2_sdc;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_o2_sdc::TH_o2_sdc(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_o2_sdc;
  NS_o2_sdc::Co2_sdc Co2_sdc_;// parallel-parser's parse table
#define ssPARSE_TABLE Co2_sdc_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_o2_sdc::PROC_TH_o2_sdc(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_o2_sdc";
  static bool one_time(false);
  static NS_o2_sdc::Co2_sdc* NS_o2_sdc_Co2_sdc_(0);// parallel-parser's fsm table
  static Parser* NS_o2_sdc_Co2_sdc_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_o2_sdc_Co2_sdc_ = new NS_o2_sdc::Co2_sdc();// parallel-parser's fsm table
    NS_o2_sdc_Co2_sdc_parser = new Parser(*NS_o2_sdc_Co2_sdc_,Caller_pp);
  }
 proc_parser = NS_o2_sdc_Co2_sdc_parser;
#include "wproc_pp_core.h"
}
void 
Co2_sdc::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Ryacco2_syntax_code_:{
       Ryacco2_syntax_code* sym;
     if(re->rule_ == 0){
       sym = new Ryacco2_syntax_code(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ryacco2_syntax_code*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->op();
     return;}
    case rhs1_Rchrs_:{
       Rchrs* sym;
     if(re->rule_ == 0){
       sym = new Rchrs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchrs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rchrs_:{
       Rchrs* sym;
     if(re->rule_ == 0){
       sym = new Rchrs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchrs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    case rhs2_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     sym->op();
     return;}
    case rhs3_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr3();
     sym->op();
     return;}
    case rhs4_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr4();
     sym->op();
     return;}
    case rhs5_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr5();
     sym->op();
     return;}
    case rhs6_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr6();
     sym->op();
     return;}
    case rhs7_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr7();
     sym->op();
     return;}
    default: return;
   }
}
